
{
open Parse
} 

let ws = [' ' '\t' '\n']

rule lexer = parse
  ws+ { lexer lexbuf }
| '(' { LLParen }
| ')' { LRParen }
| ':' { LColon }
| '.' { LDot }
| "bool" { LBool }
| "int"  { LInt }
| "->"   { LArrow }
| "true" { LTrue }
| "false" { LFalse }
| "+" { LPlus }
| ">" { LGt }
| "fn" { LFn }
| "rec"  { LRec }
| "if"   { LIf }
| "then" { LThen }
| "else" { LElse }
| '-'?['0'-'9']+ { LConst(int_of_string(Lexing.lexeme lexbuf)) }
| ['a'-'z']+  { LVar (Lexing.lexeme lexbuf) }
| eof { LEof }
